<?php

/**
 * Implementation of hook_views_handler
 *
 * Views calls this function to find out what handlers we have and what files they
 * are in; the parent is the parent handler class, so that views can load the files
 * in the right order.
 *
 */
function author_taxonomy_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'author_taxonomy'),
                   ),
    'handlers' => array(
      'author_taxonomy_handler_field_term_node_tid' => array(
        'parent' => 'views_handler_field_term_node_tid',
        'file' => 'author_taxonomy_handler_field_term_node_tid.inc',
	),
      ),
    );
}

/**
 * Implementation of hook_views_data_alter().
 *
 * This modified a $data structure that is how Views decides to call our handler
 * for the display of a particular field from a particular table.  Our handler will
 * not be called unless a field is mapped to it here.
 *
 */
function author_taxonomy_views_data_alter(&$data) {

  // tid field
  $data['term_node']['tid'] = array(
    'title' => t('Author'),
    'help' => t('Author Taxonomy'),
    'field' => array(
      'title' => t('Author terms'),
      'help' => t('Display the authors associated with the node via the author_taxonomy vocabulary.'),
      'handler' => 'author_taxonomy_handler_field_term_node_tid',
      //'skip base' => 'term_data',
    ),
  );
}

