<?php

/**
 * Field handler for terms.
 */
class author_taxonomy_handler_field_term_node_tid extends views_handler_field_term_node_tid {
  //  class author_taxonomy_handler_field_term_node_tid extends views_handler_XXXXXXXXX {

  function construct() {
    parent::construct();
  }


  function init(&$view, $options) {
    parent::init($view, $options);
  }

  function option_definition() {
    $options = parent::option_definition();
    return $options;
  }

  /**
   * Provide "link to term" option.
   */
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
  }

  /**
   * Add this term to the query
   */
  function query() {
    parent::add_additional_fields();
  }

  function pre_render($values) {
    //dsm("RGR DEBUG: in author_taxonomy handler pre_render: values= ".print_r($values, TRUE));

    $vid = variable_get('author_taxonomy_vocab', 0);
    $taxonomy = taxonomy_vocabulary_load($vid);
    // For user defined order
    if ( variable_get('author_taxonomy_user_defined_order', FALSE ) && is_array($values) && count($values) ) {
      // This section is a copy of the parent::pre_render, except that when the $this->items[] array is
      // built, it is put in the right order

      $this->field_alias = $this->aliases['vid'];
      $vids = array();
      foreach ($values as $result) {
				if (!empty($result->{$this->aliases['vid']})) {
					$vids[] = $result->{$this->aliases['vid']};
				}
      }

      if ($vids) {
				$voc = '';
				if (!empty($this->options['limit']) && !empty($this->options['vids'])) {
					$voc = " AND td.vid IN (" . implode(', ', array_keys(array_filter($this->options['vids']))) . ")";
				}

        // This query is the only thing different about this pre_render from the parent's.  An INNER JOIN
        // the author_taxonomy_term_order was added to get the weight from there instead of term_data.
        $result = db_query("SELECT tn.vid AS node_vid, td.tid, td.vid, td.name, td.description, atto.weight, 
															v.name as vocabulary FROM term_data td 
															INNER JOIN term_node tn  ON td.tid = tn.tid  
															INNER JOIN vocabulary v ON v.vid = td.vid  
															INNER JOIN author_taxonomy_term_order atto ON atto.vid = tn.vid AND atto.tid = td.tid 
															WHERE tn.vid IN (" . implode(', ', $vids) . ")$voc ORDER BY atto.weight, td.name");

				while ($term = db_fetch_object($result)) {
					$this->items[$term->node_vid][$term->tid]['name'] = check_plain($term->name);
					$this->items[$term->node_vid][$term->tid]['tid'] = $term->tid;
					$this->items[$term->node_vid][$term->tid]['vid'] = $term->vid;
					$this->items[$term->node_vid][$term->tid]['vocabulary'] = check_plain($term->vocabulary);
			
					if (!empty($this->options['link_to_taxonomy'])) {
						$this->items[$term->node_vid][$term->tid]['make_link'] = TRUE;
						$this->items[$term->node_vid][$term->tid]['path'] = taxonomy_term_path($term);
					}
				}
      }
      
    } else {
      parent::pre_render($values);
    }
  }
}

